=begin
(c) TIG 2010
Permission to use, copy, modify, and lentribute this software for 
any purpose and without fee is hereby granted, provided that the above
copyright notice appear in all copies.
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
___________________________________________________________________________

'radiallinesfixed.rb' >>> ../Plugins/ folder
___________________________________________________________________________
Usage:
Select one guide-point [cpoint] and some edges and/or faces
then run Plugins menu 'Radial Lines Fixed Length' menu items...
Enter a Length in the dialog [current units].
Line 'rays' are drawn from the cpoint towards the selected vertices using 
that Length.
___________________________________________________________________________
Donations:
by PayPal to info @ revitrev.org
___________________________________________________________________________
Version:
1.0 20100923 First release.
___________________________________________________________________________
=end
###
require 'sketchup.rb'
###
def radiallinesfixed()
  model=Sketchup.active_model
  ss=model.selection
  sa=ss.to_a
  cp=nil
  vs=[]
  sa.each{|e|
    cp=e if e.class==Sketchup::ConstructionPoint
    e.vertices.each{|v|vs << v if not vs.include?(v)} if e.class==Sketchup::Face
    if e.class==Sketchup::Edge
      vs << e.start if not vs.include?(e.start)
      vs << e.end if not vs.include?(e.end)
    end#if
  }
  if not cp
    UI.messagebox("Selection must contain a Guide-Point !")
    return nil
  end#if
  if not vs[0]
    UI.messagebox("Selection must contain a Vertex !")
    return nil
  end#if
  model.start_operation("Radial Lines Fixed")
  ###
  #ss.clear
  ### get / set length
  if model.options["UnitsOptions"]["LengthUnit"]<=1 ### '/"
    @lent=3.feet if not @lent
  else
    @lent=1.m if not @lent
  end#if
  results=inputbox(["Length: "],[@lent],"Radial Lines Fixed Length")
  return nil if not results
  @lent=results[0]
  ###
  ents=model.active_entities
  base=cp.position
  ###
  points=[]
  vs.each{|v|points << v.position}
  points.each{|p|
    pt=base.offset(base.vector_to(p), @lent)
    rl=ents.add_line(base,pt)
  }
  ###
  model.commit_operation
end
### menu
if not file_loaded?(File.basename(__FILE__))
  UI.menu("Plugins").add_item("Radial Lines Fixed Length"){radiallinesfixed()}
end#if
file_loaded(File.basename(__FILE__))
###
